/*
 * bioloid_pepper.c
 * Robotis slave-side Robotis protocol implementation for Mark Pepper's board
 */
#if defined(_Pepper_)


#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>

#include "robotis.h"




/*
 * portInitialize - sets the data directions of serial ports
 */
void InitPorts(void)
{
	DDRB = DDRC = DDRD = 0;  //Set all port to input direction first.
	PORTB = PORTC = PORTD = 0x00; //PortData initialize to 0
	//cbi(SFIOR,2); //setting 1 disables all pullups regardless of DDRx. setting to 0 does what?
	//DDRD |= (BIT_RS485_RX_DDR|BIT_RS485_TX_DDR); //set output the bit RS485direction
	DDRD = 0B11000110; // 6 (Rx gate),7 (Tx Gate), 1 (Rx), 2 (LED)

	SET_RS485_RXD;
}




/*
 * InitSerialRS485 - set the i/o pins to talk to servos
 * Baudrate - used in conjunction with prescaler...
 */
void InitSerialRS485(byte Interrupt)
{

    UCSRA = 0;// Single (not double) the USART transmission speed
    UBRRH = 0;
	UBRRL = 0;// BAUD = 1000000bps at U2X=0, Fosc=16MHz => UBRR=0  
	UCSRB = 0x18; // Receiver and Transmitter enable
	UCSRC = 0x86; // 8 bit data, no parity (and URSEL must be 1)
				// The UBRRH Register shares the same I/O location as the UCSRC Register.
				// When doing a write access of this I/O location, the high bit of the
				// value written, the USART Register Select (URSEL) bit, controls
				// which one of the two registers that will be written. If URSEL is
				// zero during a write operation, the UBRRH value will be updated.
				// If URSEL is one, the UCSRC setting will be updated. 


    if(Interrupt) sbi(UCSRB,7); // RxD interrupt enable
	//UDR = 0xFF; // puts a value in the buffer (dont know why?)
    //SET_TXRS485_FINISH; // Note. set 1, then 0 is read
	if(Interrupt) sei();
}



#endif _Pepper_
