/*
 * bioloid_pepper.c
 * Robotis slave-side Robotis protocol implementation for Mark Pepper's board
 */
#if defined(_Pepper_)


#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>

#include "robotis.h"




/*
 * portInitialize - sets the data directions of serial ports
 */
void InitPorts(void)
{
	DDRB = DDRC = DDRD = 0;  //Set all port to input direction first.
	PORTB = PORTC = PORTD = 0x00; //PortData initialize to 0
	//cbi(SFIOR,2); //setting 1 disables all pullups regardless of DDRx. setting to 0 does what?
	//DDRD |= (BIT_RS485_RX_DDR|BIT_RS485_TX_DDR); //set output the bit RS485direction
	DDRD = 0B11000110; // 6 (Rx gate),7 (Tx Gate), 1 (Rx), 2 (LED)

	SET_RS485_RXD;
}




/*
 * InitSerialRS485 - set the i/o pins to talk to servos
 * Baudrate - used in conjunction with prescaler...
 */
void InitSerialRS485(byte Baudrate, byte Interrupt)
{

    UBRRH = 0;
	UBRRL = Baudrate; 
    UCSRA = 0x02; // U2X: Double the USART transmission speed
	UCSRB = 0x18; // Receiver and Transmitter enable
    if(Interrupt) sbi(UCSRB,7); // RxD interrupt enable
    UCSRC = 0x06; // 8 bit data, no parity
	//UDR = 0xFF; // puts a value in the buffer (dont know why?)
    //SET_TXRS485_FINISH; // Note. set 1, then 0 is read
	if(Interrupt) sei();
}



#endif _Pepper_
